VERSION 5.00
Begin VB.UserControl axTree 
   ClientHeight    =   4410
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4140
   ScaleHeight     =   4410
   ScaleWidth      =   4140
   ToolboxBitmap   =   "axTree.ctx":0000
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   3180
      Left            =   315
      ScaleHeight     =   3150
      ScaleWidth      =   2625
      TabIndex        =   0
      Top             =   405
      Width           =   2655
      Begin VB.VScrollBar VScroll1 
         Height          =   1935
         Left            =   2205
         TabIndex        =   1
         Top             =   360
         Visible         =   0   'False
         Width           =   255
      End
   End
   Begin VB.Image Image1 
      Height          =   195
      Index           =   0
      Left            =   0
      Picture         =   "axTree.ctx":0312
      Top             =   0
      Visible         =   0   'False
      Width           =   195
   End
   Begin VB.Image Image1 
      Height          =   195
      Index           =   1
      Left            =   240
      Picture         =   "axTree.ctx":03FC
      Top             =   0
      Visible         =   0   'False
      Width           =   195
   End
   Begin VB.Image Image1 
      Height          =   195
      Index           =   2
      Left            =   480
      Picture         =   "axTree.ctx":04E6
      Top             =   0
      Visible         =   0   'False
      Width           =   195
   End
   Begin VB.Image Image1 
      Height          =   195
      Index           =   3
      Left            =   720
      Picture         =   "axTree.ctx":05D0
      Top             =   0
      Visible         =   0   'False
      Width           =   195
   End
   Begin VB.Image Image1 
      Height          =   195
      Index           =   4
      Left            =   960
      Picture         =   "axTree.ctx":06BA
      Top             =   0
      Visible         =   0   'False
      Width           =   195
   End
   Begin VB.Image Image1 
      Height          =   195
      Index           =   5
      Left            =   1200
      Picture         =   "axTree.ctx":07A4
      Top             =   0
      Visible         =   0   'False
      Width           =   195
   End
   Begin VB.Image Image1 
      Height          =   195
      Index           =   6
      Left            =   1440
      Picture         =   "axTree.ctx":088E
      Top             =   0
      Visible         =   0   'False
      Width           =   195
   End
   Begin VB.Image Image1 
      Height          =   195
      Index           =   7
      Left            =   1680
      Picture         =   "axTree.ctx":0978
      Top             =   0
      Visible         =   0   'False
      Width           =   195
   End
   Begin VB.Image Image1 
      Height          =   195
      Index           =   8
      Left            =   1920
      Picture         =   "axTree.ctx":0A62
      Top             =   0
      Visible         =   0   'False
      Width           =   195
   End
End
Attribute VB_Name = "axTree"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Base 1

Private mOtlSet As OtlSetup
Private mOtlData() As OtlData
Private OrderByFields As String

Private mNodes As New Collection

Const m_def_BorderStyle = 1, m_def_BorderStyleInner = 1
Const m_def_Lines = True, m_def_PlusSigns = True, m_def_CheckMarks = True
Private m_def_Setup As OtlSetup

Private m_BorderStyle As Integer, m_BorderStyleInner As Integer, iLast As Integer, m_PlusSign
Private m_Plus As Boolean, m_Lines As Boolean, m_CheckMarks As Boolean

Private m_PictureItemSelected As Picture
Private m_PictureItemNotSelected As Picture
Private m_PictureOpen As Picture
Private m_PictureOpenSome As Picture
Private m_PictureOpenAll As Picture
Private m_PictureClosed As Picture
Private m_PictureClosedSome As Picture
Private m_PictureClosedAll As Picture

Public Enum AxBorderStyles
    [No Border] = 0
    [Thin Raised] = 1
    [Thick Raised] = 2
    [Thin Inset] = 3
    [Thick Inset] = 4
    [Etched] = 5
    [Bump] = 6
End Enum

Public Enum InnerBorderStyles
    [None] = 0
    [Fixed Single] = 1
End Enum

'events
Event Click(index As Integer)
Attribute Click.VB_Description = "Occurs when user presses and then releases a mouse button over an object"
Event DblClick(index As Integer)
Attribute DblClick.VB_Description = "Occurs when user presses and then releases a mouse button and then again over an object\r\n"
Event Collapse(index As Integer)
Attribute Collapse.VB_Description = "Generated when any node in control is collapsed."
Event Expand(index As Integer)
Attribute Expand.VB_Description = "Generated when any node in control is expanded; that is, when its child nodes become visible.\r\n"

Private Sub Picture1_Click()
'these subs change the outline display, depending on the type of click registered in Mousedown
OutlineClick OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
  
  If mOtlSet.ElementClicked > 0 And mOtlSet.CurrentLine <= mOtlSet.DisplayCount Then RaiseEvent Click(mOtlSet.SelectIdx)
  If mOtlSet.LastType = 2 Then RaiseEvent Collapse(mOtlSet.SelectIdx)
  If mOtlSet.LastType = 3 Then RaiseEvent Expand(mOtlSet.SelectIdx)
  
End Sub

Private Sub Picture1_DblClick()
  If mOtlSet.ElementClicked > 0 And mOtlSet.CurrentLine <= mOtlSet.DisplayCount Then
    RaiseEvent DblClick(mOtlSet.SelectIdx)
  End If
End Sub

Private Sub Picture1_KeyDown(KeyCode As Integer, Shift As Integer)

'this routine handles cursor keys, page up, page down, +, -, etc.
OutlineKeyPress KeyCode:=KeyCode, OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes

End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
'this call deduces the line being clicked from Mousedown's x and y coordinates
OutlineMouseDown2Line Otlset:=mOtlSet, OtlDat:=mNodes, y:=y, x:=x

End Sub

Private Sub UserControl_Initialize()
  UserControl.Width = 2655: UserControl.Height = 3180
End Sub

Private Sub UserControl_InitProperties()
    m_BorderStyle = m_def_BorderStyle
    m_BorderStyleInner = m_def_BorderStyleInner
    
    m_Plus = m_def_PlusSigns
    m_Lines = m_def_Lines
    m_CheckMarks = m_def_CheckMarks

   OrderByFields = ""
   'specify bitmap logicals -- this should be done only once in a project
   OutlineBmpSetup Image1(3), m_PictureOpen, Image1(0), m_PictureClosed, Image1(6), m_PictureItemNotSelected, Image1(8), m_PictureItemNotSelected

   'Checkmarks are used with multi-select
   'OutlineBmpCheckedSetup BranchOpenAll:=Image1(4), BranchOpenSome:=Image1(5), BranchClosedAll:=Image1(1), BranchClosedSome:=Image1(2), LeafChecked:=Image1(7)
   OutlineBmpCheckedSetup Image1(4), m_PictureOpenAll, Image1(1), m_PictureClosedAll, Image1(5), m_PictureOpenSome, Image1(2), m_PictureClosedSome, Image1(7), m_PictureItemSelected

mOtlSet.Levels = 2

'test Nodes collection
AddNode "Level1", 0, True
AddNode "SubLevel1", 1, False
AddNode "SubLevel2", 1, False
AddNode "Level2", 0, False
   
End Sub

Private Sub UserControl_Resize()
  Picture1.Move 55, 50, IIf(UserControl.ScaleWidth = 0, 0, UserControl.ScaleWidth - 105), IIf(UserControl.ScaleHeight = 0, 0, UserControl.ScaleHeight - 100)
  VScroll1.Move Picture1.Width - VScroll1.Width, 0, VScroll1.Width, Picture1.Height
  
  UserControl.Cls
  UserControl_Paint
   
  If mNodes.Count > 0 Then
    'Set outline "properties"
    OutlineSetup OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, DataFields:=OrderByFields, Bmps:=True, Lines:=m_Lines, Plus:=m_Plus, Checkmarks:=m_CheckMarks, SelectColor:=&H800000, SelectTextColor:=&HFFFFFF, BmpField:="", CheckmarkField:=""
    'display the outline
    OutlineRefresh Picture1, VScroll1, mOtlSet, mNodes
  End If
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
   Dim mCaption As String, mLevel As Integer, mVisible As Integer, mExpanded As Integer
   Dim mVisibleIdx As Long, mBookmark As String, mBmpFileName As String, mSelected As Integer
   Dim mSyncIdx As Integer, mItemData As Long, mIsParent As Boolean
   
   OrderByFields = ""
    
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
    
    m_BorderStyleInner = PropBag.ReadProperty("BorderStyleInner", m_def_BorderStyleInner)
    Picture1.BorderStyle = m_BorderStyleInner
    
    m_Plus = PropBag.ReadProperty("PlusSigns", m_def_PlusSigns)
    If m_Plus Then mOtlSet.PlusFlag = 1 Else mOtlSet.PlusFlag = 0
    
    m_CheckMarks = PropBag.ReadProperty("CheckMarks", m_def_CheckMarks)
    mOtlSet.CheckmarkFlag = m_CheckMarks
    
    m_Lines = PropBag.ReadProperty("Lines", m_def_Lines)
    If m_Lines Then mOtlSet.LineFlag = 1 Else mOtlSet.LineFlag = 0
    
    Set m_PictureItemNotSelected = PropBag.ReadProperty("PictureItemNotSelected", Nothing)
    Set m_PictureItemSelected = PropBag.ReadProperty("PictureItemSelected", Nothing)
    Set m_PictureOpen = PropBag.ReadProperty("PictureOpen", Nothing)
    Set m_PictureOpenSome = PropBag.ReadProperty("PictureOpenSome", Nothing)
    Set m_PictureOpenAll = PropBag.ReadProperty("PictureOpenAll", Nothing)
    Set m_PictureClosed = PropBag.ReadProperty("PictureClosed", Nothing)
    Set m_PictureClosedSome = PropBag.ReadProperty("PictureClosedSome", Nothing)
    Set m_PictureClosedAll = PropBag.ReadProperty("PictureClosedAll", Nothing)
    
    mOtlSet.Levels = 2
    mOtlSet.VisChangeFlag = True
    Clear
    totcnt = PropBag.ReadProperty("Count", 0)
    'ReDim mOtlData(totcnt)
    For index = 1 To totcnt
      mBookmark = PropBag.ReadProperty("List_1" & index)
      mCaption = PropBag.ReadProperty("List_2" & index)
      mExpanded = PropBag.ReadProperty("List_3" & index)
      mIsParent = PropBag.ReadProperty("List_4" & index)
      mItemData = PropBag.ReadProperty("List_5" & index)
      mLevel = PropBag.ReadProperty("List_6" & index)
      mSelected = PropBag.ReadProperty("List_7" & index)
      mSyncIdx = PropBag.ReadProperty("List_8" & index)
      mVisible = PropBag.ReadProperty("List_9" & index)
      mVisibleIdx = PropBag.ReadProperty("List_10" & index)
      AddNode mCaption, mLevel, mIsParent, , mVisible, mExpanded, mVisibleIdx, mBookmark, mSelected, mSyncIdx, mItemData
    Next
       
   'specify bitmap logicals -- this should be done only once in a project
   'OutlineBmpSetup BranchOpen:=Image1(3), BoFile:="", BranchClosed:=Image1(0), BcFile:="", Leaf:=Image1(6), LFile:="", CustomPic:=Image1(8)
   OutlineBmpSetup Image1(3), m_PictureOpen, Image1(0), m_PictureClosed, Image1(6), m_PictureItemNotSelected, Image1(8), m_PictureItemNotSelected

   'Checkmarks are used with multi-select
   OutlineBmpCheckedSetup Image1(4), m_PictureOpenAll, Image1(1), m_PictureClosedAll, Image1(5), m_PictureOpenSome, Image1(2), m_PictureClosedSome, Image1(7), m_PictureItemSelected
   
   'Set outline "properties"
   OutlineSetup OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, DataFields:=OrderByFields, Bmps:=True, Lines:=m_Lines, Plus:=m_Plus, Checkmarks:=m_CheckMarks, SelectColor:=&H800000, SelectTextColor:=&HFFFFFF, BmpField:="", CheckmarkField:=""
   'redisplay the outline
   OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
    
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
    Call PropBag.WriteProperty("BorderStyleInner", m_BorderStyleInner, m_def_BorderStyleInner)
    Call PropBag.WriteProperty("PlusSigns", m_Plus, m_def_PlusSigns)
    Call PropBag.WriteProperty("CheckMarks", m_CheckMarks, m_def_CheckMarks)
    Call PropBag.WriteProperty("Lines", m_Lines, m_def_Lines)
    Call PropBag.WriteProperty("PictureItemNotSelected", m_PictureItemNotSelected, "")
    Call PropBag.WriteProperty("PictureItemSelected", m_PictureItemSelected, "")
    Call PropBag.WriteProperty("PictureOpen", m_PictureOpen, "")
    Call PropBag.WriteProperty("PictureOpenSome", m_PictureOpenSome, "")
    Call PropBag.WriteProperty("PictureOpenAll", m_PictureOpenAll, "")
    Call PropBag.WriteProperty("PictureClosed", m_PictureClosed, "")
    Call PropBag.WriteProperty("PictureClosedSome", m_PictureClosedSome, "")
    Call PropBag.WriteProperty("PictureClosedAll", m_PictureClosedAll, "")

    If Not UserControl.Ambient.UserMode Then
    Call PropBag.WriteProperty("Count", mNodes.Count, 0)
    For index = 1 To mNodes.Count
      Call PropBag.WriteProperty("List_1" & index, mNodes(index).Bookmark)
      Call PropBag.WriteProperty("List_2" & index, mNodes(index).Caption)
      Call PropBag.WriteProperty("List_3" & index, mNodes(index).Expanded)
      Call PropBag.WriteProperty("List_4" & index, mNodes(index).IsParent)
      Call PropBag.WriteProperty("List_5" & index, mNodes(index).ItemData)
      Call PropBag.WriteProperty("List_6" & index, mNodes(index).Level)
      Call PropBag.WriteProperty("List_7" & index, mNodes(index).Selected)
      Call PropBag.WriteProperty("List_8" & index, mNodes(index).SyncIdx)
      Call PropBag.WriteProperty("List_9" & index, mNodes(index).Visible)
      Call PropBag.WriteProperty("List_10" & index, mNodes(index).VisibleIdx)
    Next
    End If
    
End Sub

Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Show about box for control"
Attribute ShowAbout.VB_UserMemId = -552
  frmAbout.Show vbModal
End Sub
'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events\r\n"
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property

Public Property Get BorderStyle() As AxBorderStyles
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object"
    BorderStyle = m_BorderStyle
End Property
Public Property Let BorderStyle(ByVal New_BorderStyle As AxBorderStyles)
    If Not (m_BorderStyle = New_BorderStyle) Then
        m_BorderStyle = New_BorderStyle
        UserControl.Cls
        UserControl_Paint
    End If
    PropertyChanged "BorderStyle"
End Property

Public Property Get BorderStyleInner() As InnerBorderStyles
Attribute BorderStyleInner.VB_Description = "Returns/set the inner border style for the control"
    BorderStyleInner = m_BorderStyleInner
End Property

Public Property Let BorderStyleInner(ByVal New_InnerBorder As InnerBorderStyles)
    m_BorderStyleInner = New_InnerBorder
    Picture1.BorderStyle = New_InnerBorder
    PropertyChanged "BorderStyleInner"
End Property

Public Property Get PlusSigns() As Boolean
Attribute PlusSigns.VB_Description = "Returns/sets a valute to determine whether the parent indicators (plus signs) are displayed on control.\r\n"
    PlusSigns = m_Plus
End Property
Public Property Let PlusSigns(ByVal New_PlusSigns As Boolean)
    If Not (m_Plus = New_PlusSigns) Then
        m_Plus = New_PlusSigns
        
        If m_Plus Then mOtlSet.PlusFlag = 1 Else mOtlSet.PlusFlag = 0
        mOtlSet.VisChangeFlag = True
        OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
    End If
    PropertyChanged "PlusSigns"
End Property

Public Property Get Lines() As Boolean
Attribute Lines.VB_Description = "Returns/sets a value to determine whether node lines are displayed on control.\r\n"
    Lines = m_Lines
End Property
Public Property Let Lines(ByVal New_Lines As Boolean)
    If Not (m_Lines = New_Lines) Then
        m_Lines = New_Lines
        
        If m_Lines Then mOtlSet.LineFlag = 1 Else mOtlSet.LineFlag = 0
        mOtlSet.VisChangeFlag = True
        OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
        'UserControl.Cls
        'UserControl_Paint
    End If
    PropertyChanged "Lines"
End Property

Public Property Get Checkmarks() As Boolean
Attribute Checkmarks.VB_Description = "Returns/sets a value to determine if user has the ability to mark multiple lines in the hierarchy list\r\n"
    Checkmarks = m_CheckMarks
End Property
Public Property Let Checkmarks(ByVal New_CheckMarks As Boolean)
    If Not (m_CheckMarks = New_CheckMarks) Then
        m_CheckMarks = New_CheckMarks
        
        mOtlSet.CheckmarkFlag = m_CheckMarks
        OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
        'UserControl.Cls
        'UserControl_Paint
    End If
    PropertyChanged "CheckMarks"
End Property

Private Sub UserControl_Paint()
    Dim di As Long
    Dim rc As RECT
    
    'draw outside border
        
    Select Case m_BorderStyle
        Case [No Border]
        
        Case [Thin Raised]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hDC, rc, BDR_RAISEDINNER, BF_TOPLEFT)
            di = DrawEdge(UserControl.hDC, rc, BDR_RAISEDOUTER, BF_BOTTOMRIGHT)
        
        Case [Thick Raised]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hDC, rc, EDGE_RAISED, BF_TOPLEFT)
            di = DrawEdge(UserControl.hDC, rc, EDGE_RAISED, BF_BOTTOMRIGHT)
    
        Case [Thin Inset]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hDC, rc, BDR_SUNKENINNER, BF_TOPLEFT)
            di = DrawEdge(UserControl.hDC, rc, BDR_SUNKENOUTER, BF_BOTTOMRIGHT)
        
        Case [Thick Inset]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hDC, rc, EDGE_SUNKEN, BF_TOPLEFT)
            di = DrawEdge(UserControl.hDC, rc, EDGE_SUNKEN, BF_BOTTOMRIGHT)
        
        Case [Etched]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hDC, rc, EDGE_ETCHED, BF_TOPLEFT)
            di = DrawEdge(UserControl.hDC, rc, EDGE_ETCHED, BF_BOTTOMRIGHT)
    
        Case [Bump]
            di = GetClientRect(UserControl.hwnd, rc)
            di = DrawEdge(UserControl.hDC, rc, EDGE_BUMP, BF_TOPLEFT)
            di = DrawEdge(UserControl.hDC, rc, EDGE_BUMP, BF_BOTTOMRIGHT)
            
    End Select
        
End Sub


Private Sub VScroll1_Change()
'page or scroll the display based on scrollbar clicks
OutlineScroll ScrollValue:=VScroll1.Value, OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes

End Sub

Public Property Get SelectedItem() As Integer
Attribute SelectedItem.VB_Description = "Returns/sets the currently selected node object\r\n"
Attribute SelectedItem.VB_MemberFlags = "400"
    SelectedItem = mOtlSet.SelectIdx
End Property
Public Property Let SelectedItem(ByVal New_SelectedItem As Integer)
    mOtlSet.SelectIdx = New_SelectedItem
    OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
    
    PropertyChanged "SelectedItem"
End Property

Public Property Get Count() As Integer
Attribute Count.VB_Description = "Returns total number of node objects in Nodes collection"
  Count = mNodes.Count
End Property
Public Sub Clear()
Attribute Clear.VB_Description = "Clear all node objects from Nodes collection"
  Do Until mNodes.Count = 0
    mNodes.Remove 1
  Loop
  
  mOtlSet.Levels = 0
   'Set outline "properties"
   OutlineSetup OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, DataFields:=OrderByFields, Bmps:=True, Lines:=m_Lines, Plus:=m_Plus, Checkmarks:=m_CheckMarks, SelectColor:=&H800000, SelectTextColor:=&HFFFFFF, BmpField:="", CheckmarkField:=""
   'redisplay the outline
   OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
End Sub

Public Function AddNode(mCaption As String, mLevel As Integer, mIsParent As Boolean, _
                                Optional mAfter, Optional mVisible, Optional mExpanded, Optional mVisibleIdx, _
                                Optional mBookmark, Optional mSelected, Optional mSyncIdx, _
                                Optional mItemData)
Attribute AddNode.VB_Description = "Adds a node object to a control's Nodes collection"
   Dim TopNode As Integer
   Dim newitem As New clsItem
  
   TopNode = mNodes.Count
   If Level <= 1 And mOtlSet.Levels < 2 Then
     mOtlSet.Levels = 2
   ElseIf mOtlSet.Levels < Level + 1 Then
     mOtlSet.Levels = Level + 1
   End If
  
  With newitem
    .Caption = mCaption
    .Level = mLevel
    .IsParent = mIsParent
    .Visible = IIf(IsMissing(mVisible), True, mVisible)
    .Expanded = IIf(IsMissing(mExpanded), True, mExpanded)
    .VisibleIdx = IIf(IsMissing(mVisibleIdx), 0, mVisibleIdx)
    .Bookmark = IIf(IsMissing(mBookmark), "", mBookmark)
    .BmpFileName = IIf(IsMissing(mBmpFileName), "", mBmpFileName)
    .Selected = IIf(IsMissing(mSelected), 0, mSelected)
    .SyncIdx = IIf(IsMissing(mSyncIdx), 0, mSyncIdx)
    .ItemData = IIf(IsMissing(mItemData), 0, mItemData)
  End With
   
  If IsMissing(mAfter) Then
      mNodes.Add newitem
  Else
      mNodes.Add newitem, , , mAfter
  End If
  'Add = True
  
   'Set outline "properties"
   OutlineSetup OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, DataFields:=OrderByFields, Bmps:=True, Lines:=m_Lines, Plus:=m_Plus, Checkmarks:=m_CheckMarks, SelectColor:=&H800000, SelectTextColor:=&HFFFFFF, BmpField:="", CheckmarkField:=""
   'redisplay the outline
   OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
  
End Function

Public Sub CollapseAll()
Attribute CollapseAll.VB_Description = "Collapse all nodes in Nodes collection list so that no child nodes are visible"
  OutlineCollapseAll Picture1, VScroll1, mOtlSet, mNodes
End Sub

Public Sub ExpandAll()
Attribute ExpandAll.VB_Description = "Expand all nodes in Nodes collection so that all child nodes are visible"
  OutlineExpandAll Picture1, VScroll1, mOtlSet, mNodes
End Sub

Public Sub Find(arg As String, Mode As Integer)
Attribute Find.VB_Description = "Find a node object by its caption name"
  OutlineFind arg, Mode, Picture1, VScroll1, mOtlSet, mNodes
End Sub

Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a form or control"
  'Set outline "properties"
  OutlineSetup OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, DataFields:=OrderByFields, Bmps:=True, Lines:=m_Lines, Plus:=m_Plus, Checkmarks:=m_CheckMarks, SelectColor:=&H800000, SelectTextColor:=&HFFFFFF, BmpField:="", CheckmarkField:=""
  'redisplay the outline
  OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
  UserControl.Refresh
End Sub

Public Sub RemoveNode(index As Integer)
Attribute RemoveNode.VB_Description = "Remove node object from Nodes collection"
  If mNodes.Count = 0 Then Exit Sub
  mNodes.Remove index
  'Set outline "properties"
  OutlineSetup OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, DataFields:=OrderByFields, Bmps:=True, Lines:=m_Lines, Plus:=m_Plus, Checkmarks:=m_CheckMarks, SelectColor:=&H800000, SelectTextColor:=&HFFFFFF, BmpField:="", CheckmarkField:=""
  'redisplay the outline
  OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
End Sub

Public Function Item(ByVal key As Variant) As Object
Attribute Item.VB_Description = "Returns a node object bu index or by key"
  On Error GoTo errorexit
  If VarType(key) = vbString Then
    key = Trim(key)
  End If
  
  Set Item = mNodes.Item(key)
  Exit Function
  
errorexit:
  
End Function


Public Property Get PictureItemSelected() As Picture
Attribute PictureItemSelected.VB_Description = "Bitmap to display for node item selected"
    Set PictureItemSelected = m_PictureItemSelected
End Property

Public Property Set PictureItemSelected(ByVal New_PictureItemSelected As Picture)
    Set m_PictureItemSelected = New_PictureItemSelected
    mOtlSet.VisChangeFlag = True
   OutlineBmpCheckedSetup Image1(4), m_PictureOpenAll, Image1(1), m_PictureClosedAll, Image1(5), m_PictureOpenSome, Image1(2), m_PictureClosedSome, Image1(7), m_PictureItemSelected
    OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
End Property

Public Property Get PictureItemNotSelected() As Picture
Attribute PictureItemNotSelected.VB_Description = "Bitmap to display for node item not selected"
    Set PictureItemNotSelected = m_PictureItemNotSelected
End Property

Public Property Set PictureItemNotSelected(ByVal New_PictureItemNotSelected As Picture)
    Set m_PictureItemNotSelected = New_PictureItemNotSelected
    
    MsgBox IIf(m_PictureItemNotSelected Is Nothing, "Nothing", "Picture")
    
    mOtlSet.VisChangeFlag = True
    OutlineBmpSetup Image1(3), m_PictureOpen, Image1(0), m_PictureClosed, Image1(6), m_PictureItemNotSelected, Image1(8), m_PictureItemNotSelected
    OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
End Property

Public Property Get PictureOpen() As Picture
Attribute PictureOpen.VB_Description = "Bitmap to display for open node with no subitems selected"
    Set PictureOpen = m_PictureOpen
End Property

Public Property Set PictureOpen(ByVal New_PictureOpen As Picture)
    Set m_PictureOpen = New_PictureOpen
    mOtlSet.VisChangeFlag = True
    OutlineBmpSetup Image1(3), m_PictureOpen, Image1(0), m_PictureClosed, Image1(6), m_PictureItemNotSelected, Image1(8), m_PictureItemNotSelected
    OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
End Property

Public Property Get PictureOpenSome() As Picture
Attribute PictureOpenSome.VB_Description = "Bitmap to display for open node with some subitems selected"
    Set PictureOpenSome = m_PictureOpenSome
End Property

Public Property Set PictureOpenSome(ByVal New_PictureOpenSome As Picture)
    Set m_PictureOpenSome = New_PictureOpenSome
    mOtlSet.VisChangeFlag = True
   OutlineBmpCheckedSetup Image1(4), m_PictureOpenAll, Image1(1), m_PictureClosedAll, Image1(5), m_PictureOpenSome, Image1(2), m_PictureClosedSome, Image1(7), m_PictureItemSelected
    OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
End Property

Public Property Get PictureOpenAll() As Picture
Attribute PictureOpenAll.VB_Description = "Bitmap to display for open node with all subitems selected"
    Set PictureOpenAll = m_PictureOpenAll
End Property

Public Property Set PictureOpenAll(ByVal New_PictureOpenAll As Picture)
    Set m_PictureOpenAll = New_PictureOpenAll
    mOtlSet.VisChangeFlag = True
   OutlineBmpCheckedSetup Image1(4), m_PictureOpenAll, Image1(1), m_PictureClosedAll, Image1(5), m_PictureOpenSome, Image1(2), m_PictureClosedSome, Image1(7), m_PictureItemSelected
    OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
End Property

Public Property Get PictureClosed() As Picture
Attribute PictureClosed.VB_Description = "Bitmap to display for closed node with no subitems selected"
    Set PictureClosed = m_PictureClosed
End Property

Public Property Set PictureClosed(ByVal New_PictureClosed As Picture)
    Set m_PictureClosed = New_PictureClosed
    mOtlSet.VisChangeFlag = True
    OutlineBmpSetup Image1(3), m_PictureOpen, Image1(0), m_PictureClosed, Image1(6), m_PictureItemNotSelected, Image1(8), m_PictureItemNotSelected
    OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
End Property

Public Property Get PictureClosedSome() As Picture
Attribute PictureClosedSome.VB_Description = "Bitmap to display for closed node with some subitems selected"
    Set PictureClosedSome = m_PictureClosedSome
End Property

Public Property Set PictureClosedSome(ByVal New_PictureClosedSome As Picture)
    Set m_PictureClosedSome = New_PictureClosedSome
    mOtlSet.VisChangeFlag = True
   OutlineBmpCheckedSetup Image1(4), m_PictureOpenAll, Image1(1), m_PictureClosedAll, Image1(5), m_PictureOpenSome, Image1(2), m_PictureClosedSome, Image1(7), m_PictureItemSelected
    OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
End Property

Public Property Get PictureClosedAll() As Picture
Attribute PictureClosedAll.VB_Description = "Bitmap to display for closed node with all subitems selected"
    Set PictureClosedAll = m_PictureClosedAll
End Property

Public Property Set PictureClosedAll(ByVal New_PictureClosedAll As Picture)
    Set m_PictureClosedAll = New_PictureClosedAll
    mOtlSet.VisChangeFlag = True
   OutlineBmpCheckedSetup Image1(4), m_PictureOpenAll, Image1(1), m_PictureClosedAll, Image1(5), m_PictureOpenSome, Image1(2), m_PictureClosedSome, Image1(7), m_PictureItemSelected
    OutlineRefresh OtlPic:=Picture1, OtlScroll:=VScroll1, Otlset:=mOtlSet, OtlDat:=mNodes
End Property


